<!-- 固定资产页面 -->
<script lang="ts" setup>
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import addDialog from './components/fixedAssetsAdd.vue'
import type { fixedAssetsType } from './standingBook-interface'
import { exportFile } from '@/utils/exportUtils'
import { assetsDeleteApi, listExportApi, listImporttApi, listPageApi } from '@/api/device/standingBook'
const { proxy } = getCurrentInstance() as any
const searchQuery = reactive({
  assetNo: '', // 固定编号
  equipmentName: '', // 设备名称
  modelNo: '', // 型号
  equipmentSpecifications: '', // 设备规格
  equipmentCategory: '', // 设备类型
  limit: 10,
  offset: 1,
}) // 查询参数
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns = ref([
  {
    text: '固定资产编号',
    value: 'assetNo',
    width: '180',
    align: 'center',
  },
  {
    text: '设备名称',
    value: 'equipmentName',
    width: '150',
    align: 'center',
  },
  {
    text: '型号',
    value: 'modelNo',
    width: '150',
    align: 'center',
  },
  {
    text: '设备规格',
    value: 'equipmentSpecifications',
    width: '150',
    align: 'center',
  },
  {
    text: '设备类别',
    value: 'equipmentCategoryName',
    width: '150',
    align: 'center',
  },
  {
    text: '设备类型',
    value: 'assetTypeName',
    width: '150',
    align: 'center',
  },
  {
    text: '用途',
    value: 'purpose',
    width: '150',
    align: 'center',
  },
  {
    text: '管理级别',
    value: 'managerLevelName',
    width: '150',
    align: 'center',
  },
  {
    text: '使用单位',
    value: 'useDeptName',
    width: '150',
    align: 'center',
  },
  {
    text: '创建时间',
    value: 'createTime',
    width: '180',
    align: 'center',
  },
]) // 表格
const printObj = ref({
  id: 'print', // 需要打印元素的id
  popTitle: '固定资产', // 打印配置页上方的标题
  extraHead: '', // 最上方的头部文字，附加在head标签上的额外标签，使用逗号分割
  preview: false, // 是否启动预览模式，默认是false
  previewBeforeOpenCallback() { console.log('正在加载预览窗口！') }, // 预览窗口打开之前的callback
  previewOpenCallback() { console.log('已经加载完预览窗口，预览打开了！') }, // 预览窗口打开时的callback
  beforeOpenCallback() { console.log('开始打印之前！') }, // 开始打印之前的callback
  openCallback() { console.log('执行打印了！') }, // 调用打印时的callback
  closeCallback() { console.log('关闭了打印工具！') }, // 关闭打印的callback(无法区分确认or取消)
  clickMounted() { console.log('点击v-print绑定的按钮了！') },
  // url: 'http://localhost:8080/', // 打印指定的URL，确保同源策略相同
  // asyncUrl (reslove) {
  //   setTimeout(() => {
  //     reslove('http://localhost:8080/')
  //   }, 2000)
  // },
  standard: '',
  extarCss: '',
})
const list = ref([]) // 表格数据
const addRef = ref() // 添加/编辑/详情/组件
const dialogVisible = ref<boolean>(false) // 添加组件的显示与隐藏
// 获取数据列表
const getList = () => {
  loadingTable.value = true
  listPageApi(searchQuery).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getList()
}
// 详情
const detail = (row: fixedAssetsType) => {
  console.log(row, 'row')
  dialogVisible.value = true
  addRef.value.initDialog({
    title: '详情',
    ...row,
  })
}
// 编辑
const update = (row: fixedAssetsType) => {
  dialogVisible.value = true
  addRef.value.initDialog({
    title: '编辑',
    ...row,
  })
}
// 删除
const remove = (row: fixedAssetsType) => {
  ElMessageBox.confirm(
    `确认删除${row.equipmentName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      assetsDeleteApi({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          getList()
        }
      })
    })
}
// 搜索
const search = () => {
  getList()
}
// 重置
const reset = () => {
  searchQuery.assetNo = ''
  searchQuery.equipmentName = ''
  searchQuery.modelNo = ''
  searchQuery.equipmentSpecifications = ''
  searchQuery.equipmentCategory = ''
  getList()
}
// 模板下载
const templateDownload = () => {

}
// 标签识别
const identify = () => {

}
// 新增
const add = () => {
  dialogVisible.value = true
  addRef.value.initDialog({
    title: '新建',
  })
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })

  listExportApi({ ...searchQuery, limit: undefined, offset: undefined }).then((res) => {
    exportFile(res.data, '固定资产列表')
    loading.close()
  }).catch((_) => {
    loading.close()
  })
}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传图片
  // console.log(event.target.files)
  // if (event.target.files[0].type === 'application/pdf') {
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    listImporttApi(fd).then((res) => {
      if (res.code === 200) {
        ElMessage.success('上传成功')
      }
      else {
        ElMessage.error(res.message)
      }
    })
  }
//   }
//   else {
//     ElMessage.error('请上传pdf格式')
//   }
}
// 批量导入
const batchImport = () => {
  fileRef.value.click()
}
// 传给子组件的刷新事件
const refreshDta = () => {
  getList()
  dialogVisible.value = false
}
onMounted(() => {
  getList()
})
</script>

<template>
  <div>
    <add-dialog v-show="dialogVisible" ref="addRef" @reset-data="refreshDta" />
    <!-- 布局 -->
    <app-container v-show="!dialogVisible">
      <!-- 筛选条件 -->
      <search-area :need-clear="true" @search="search" @clear="reset">
        <search-item>
          <el-input v-model="searchQuery.assetNo" placeholder="固定编号" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.equipmentName" placeholder="设备名称" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.modelNo" placeholder="型号" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.equipmentSpecifications" placeholder="设备规格" clearable class="w-50 m-2" />
        </search-item>
        <search-item>
          <el-input v-model="searchQuery.equipmentCategory" placeholder="设备类型" clearable class="w-50 m-2" />
        </search-item>
      </search-area>
      <table-container>
        <!-- 表头区域 -->
        <template #btns-right>
          <input v-show="(searchQuery.limit === 0)" ref="fileRef" type="file" multiple @change="onFileChange">
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/identify`)" type="primary" @click="identify">
            标签识别
          </el-button>
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/import`)" type="primary" @click="batchImport">
            批量导入
          </el-button>
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/mould`)" type="primary" @click="templateDownload">
            模板下载
          </el-button>
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/add`)" type="primary" @click="add">
            新建
          </el-button>
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/export`)" type="primary" @click="exportExcelBtn">
            导出
          </el-button>
          <el-button v-if="proxy.hasPerm(`/device/fixedAssets/print`)" v-print="printObj" type="primary">
            打印
          </el-button>
        </template>
        <!-- 表格区域 -->
        <normal-table
          id="print"
          :data="list" :total="total" :columns="columns as any"
          :is-showmulti-select="true"
          :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
          :list-loading="loadingTable"
          @change="changePage"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column label="操作" align="center" width="180" fixed="right">
              <template #default="{ row }">
                <el-button v-if="proxy.hasPerm(`/device/fixedAssets/update`)" size="small" type="primary" link @click="update(row)">
                  编辑
                </el-button>
                <el-button v-if="proxy.hasPerm(`/device/fixedAssets/detail`)" size="small" type="primary" link @click="detail(row)">
                  查看
                </el-button>
                <el-button v-if="proxy.hasPerm(`/device/fixedAssets/delete`)" size="small" type="danger" link @click="remove(row)">
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 154px !important;
}

.normal-date {
  width: 154px !important;
}

.normal-select {
  width: 154px !important;
}

:deep(.el-table__header) {
  background-color: #bbb;
}
</style>

